FLATARITYEXPR(3)

NAME
flatArityExpr - flattens the operators of an expression

SYNOPSYS
#include "logmmm.h"
void *latArityExpr(expr)
chain_list *expr;

PARAMETER

expr
    expression to flatten

DESCRIPTION
flatArityExpr() removes the useless operators. This function doesn't make any simplifications.

EXAMPLE
#include "mutnnn.h"		/* mbk utilities */
#include "logmmm.h"
chain_list *expr1,*expr2,*expr3;
expr1 = createExpr(OR);
addQExpr(expr1,createAtom("a"));
addQExpr(expr1,createAtom("b"));
expr2 = createExpr(OR);
addQExpr(expr2,createAtom("a"));
addQExpr(expr2,createAtom("c"));
addQExpr(expr1,expr2);
expr3 = copyExpr(expr1);
flatArityExpr(expr3);
displayExpr(expr1);
displayExpr(expr3);
/* it will display
(OR a b (OR a c))
(OR a b a c)
*/
freeExpr(expr1);
freeExpr(expr3);

SEE ALSO
log(1), abl(1), flatPolarityExpr(3), copyExpr(3), substExpr(3), substPhyExpr(3), maxExpr(3), minExpr(3), sortExpr(3), normExpr(3).